with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.IHTMLFrameElement3_Interface is

   procedure Initialize (This : in out IHTMLFrameElement3_Type) is
   begin
      Set_IID (This, IID_IHTMLFrameElement3);
   end Initialize;

   function Pointer (This : IHTMLFrameElement3_Type)
     return Pointer_To_IHTMLFrameElement3
   is
   begin
      return To_Pointer_To_IHTMLFrameElement3 (Address (This));
   end Pointer;

   procedure Attach (This    : in out IHTMLFrameElement3_Type;
                     Pointer : in     Pointer_To_IHTMLFrameElement3)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   function Get_contentDocument
     (This : IHTMLFrameElement3_Type)
     return GNATCOM.Types.Pointer_To_IDispatch
   is
       RetVal : aliased GNATCOM.Types.Pointer_To_IDispatch;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_contentDocument
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_contentDocument;

   procedure Put_src
     (This : IHTMLFrameElement3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_src
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_src;

   function Get_src
     (This : IHTMLFrameElement3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_src
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_src;

   procedure Put_longDesc
     (This : IHTMLFrameElement3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_longDesc
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_longDesc;

   function Get_longDesc
     (This : IHTMLFrameElement3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_longDesc
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_longDesc;

   procedure Put_frameBorder
     (This : IHTMLFrameElement3_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_frameBorder
         (Pointer (This),
          p));

      if Free then
               GNATCOM.IInterface.Free (p);
      
      end if;

   end Put_frameBorder;

   function Get_frameBorder
     (This : IHTMLFrameElement3_Type)
     return GNATCOM.Types.BSTR
   is
       RetVal : aliased GNATCOM.Types.BSTR;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_frameBorder
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_frameBorder;

end MSHTML.IHTMLFrameElement3_Interface;

